
// This example sends to the ArduHAL application
// the distance measured with the VL53L0X sensor. 

#include <Theremino.h>
#include <Wire.h>
#include "VL53L0X.h"

VL53L0X sensor;

void setup()
{
    // ----------------------------------------------------------------
    // Calling setAsyncMode() the timer0 compare interrupt is used.
    // The ArduHAL exchange frequency is independent by the "loop()"
    // but the max frequency drops from about 300 to about 200 fps
    // ----------------------------------------------------------------
    //Theremino.setAsyncMode();
	
	// ----------------------------------------------------------------
    //  This baud rate must be the same as in the ArduHAL CommOptions
    //  Any baud rate from 1000 to 1000000 is valid
    //  More used baud rates are : 500000 250000 115200
    // ----------------------------------------------------------------
	Serial.begin(500000);
	
	Wire.begin();
	sensor.init();
	sensor.startContinuous(); // repeat measurements as fast as possible
}

void loop()
{
	Theremino.genericWrite16(1, sensor.readRangeContinuousMillimetersNonStopping());

	// ----------------------------------------------------------------
	//  Debug
	// ----------------------------------------------------------------
	// Serial.print(sensor.readRangeContinuousMillimetersNonStopping());
	// Serial.println();
}
